=== src/LV2/gx_alembic.lv2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

def configure(conf):
    pass

def build(bld):
    lv2_base = 'gx_alembic'

    bld.lv2(
        lv2_base = lv2_base,
        source   = ['gx_alembic.cpp'],
        includes = ['../faust','./', '../DSP', '../DSP/tube_tables', '../DSP/circuit_tables'],
        cxxflags=['-fvisibility=hidden','-Wl,-z,noexecstack','-Wl,-z,relro,-z,now','-Wl,--exclude-libs,ALL'],
        use = ['LV2CORE'],
        )
    bld.lv2_gui(
        lv2_base = lv2_base,
        source   = ' gx_alembic_ui.cpp',
        includes = ['../xputty/header','../xputty/header/widgets','../xputty/resources', '../xputty/lv2_plugin'],
        cxxflags=['-fvisibility=hidden','-Wl,-z,noexecstack','-Wl,-z,relro,-z,now','-Wl,--exclude-libs,ALL'],
        use = ['xcairo','X11', 'CAIRO','LV2CORE'],
        )
