=== debian/changelog ===
guitarix (0.47.0+dfsg-1) unstable; urgency=medium

  * New upstream version 0.47.0+dfsg
  * Bump Standards-Version to 4.7.2
  * Refresh d/source/lintian-overrides
  * d/copyright: Update GPL-2 license text
  * Update my d/copyright year
  * Remove redudant Rules-Requires-Root: no

 -- Dennis Braun <snd@debian.org>  Sun, 09 Nov 2025 23:04:37 +0100
