=== debian/control ===
Source: guitarix
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Víctor Cuadrado Juan <me@viccuad.me>,
 Dennis Braun <snd@debian.org>,
Build-Depends: dpkg-dev (>= 1.22.5),
 debhelper-compat (= 13),
 fonts-roboto,
 gperf,
 intltool,
 libavahi-gobject-dev,
 libbluetooth-dev [linux-any],
 libboost-dev,
 libboost-iostreams-dev,
 libboost-system-dev,
 libboost-thread-dev,
 libeigen3-dev,
 libfftw3-dev,
 libgtk-3-dev,
 libgtkmm-3.0-dev,
 libjack-dev | libjack-jackd2-dev,
 liblilv-dev,
 liblrdf0-dev,
 libsndfile1-dev,
 libzita-convolver-dev,
 libzita-resampler-dev,
 lv2-dev,
 python3,
 sassc,
Build-Depends-Indep:
 doxygen,
 graphviz,
Standards-Version: 4.7.2
Homepage: https://guitarix.org
Vcs-Git: https://salsa.debian.org/multimedia-team/guitarix.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/guitarix

Package: guitarix
Architecture: any
Depends:
 fonts-roboto,
 guitarix-common (= ${source:Version}),
 guitarix-lv2 (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 gvfs-backends,
 jack-capture,
 lame,
 vorbis-tools,
Description: Rock guitar amplifier for JACK
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It provides one JACK input port and two JACK output
 ports. It is designed to produce nice thrash/metal/rock/blues guitar sounds.
 Controls for bass, treble, gain, compressor, tube selector, distortion,
 flanger, freeverb, crybaby (wah), etc are available.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package provides the standalone application with a GTK+ interface.

Package: guitarix-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Guitarix - Common files
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 thrash/metal/rock/blues guitar sounds.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package contains Guitarix's Architecture independent files. Examples of
 such shared files are: configuration files, images and sounds.

Package: guitarix-lv2
Architecture: any
Provides:
 lv2-plugin,
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Guitarix - LV2 plugins
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 thrash/metal/rock/blues guitar sounds.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package contains the LV2 audio plugins that come together with guitarix,
 but can also be used by any other LV2 host.

Package: guitarix-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 ${misc:Depends},
Suggests:
 guitarix,
Description: Guitarix - Development documentation
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 thrash/metal/rock/blues guitar sounds.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package contains Guitarix's Development documentation.

Package: libgxw0t64
Provides: ${t64:Provides}
Replaces: libgxw0
Breaks: libgxw0 (<< ${source:Version})
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Guitarix - GTK+ library
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 thrash/metal/rock/blues guitar sounds.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package contains Guitarix's GTK+ library.

Package: libgxw-dev
Section: libdevel
Architecture: any
Depends:
 libgxw0t64 (= ${binary:Version}),
 ${misc:Depends},
Recommends:
 guitarix-doc,
Description: Guitarix - GTK+ library (development files)
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 thrash/metal/rock/blues guitar sounds.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package contains development files for Guitarix's GTK+ library.

Package: libgxwmm0t64
Provides: ${t64:Provides}
Replaces: libgxwmm0
Breaks: libgxwmm0 (<< ${source:Version})
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Guitarix - GTK+ C++ widget library
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 thrash/metal/rock/blues guitar sounds.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package contains Guitarix's GTK+ C++ widget library.

Package: libgxwmm-dev
Section: libdevel
Architecture: any
Depends:
 libgxwmm0t64 (= ${binary:Version}),
 ${misc:Depends},
Recommends:
 guitarix-doc,
Description: Guitarix - GTK+ C++ widget library (development files)
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 thrash/metal/rock/blues guitar sounds.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package contains development files for Guitarix's GTK+ C++ widget library.
