=== debian/watch ===
version=4
opts="dversionmangle=auto,searchmode=plain" \
 https://api.github.com/repos/brummer10/@PACKAGE@/releases?per_page=100 \
 https://github.com/brummer10/@PACKAGE@/releases/download/V?[\d.]+/@PACKAGE@2-@ANY_VERSION@@ARCHIVE_EXT@ \
 debian debian/repack-waf.sh
